<sqtm-core-configurable-banner />

<div
  #mainContainer
  class="full-height full-width workbench-layout-3-cols flex-row overflow-hidden neutral-background-color"
>
  <!--  Left part, controls are here-->
  <div class="full-height flex-fixed-size flex-column overflow-hidden">
    <div class="flex-row">
      <sqtm-core-back-button
        class="m-t-6 p-10"
        (buttonPressed)="handleCancel()"
      >
      </sqtm-core-back-button>
      <div
        class="sqtm-core-screen-title title__underline p-b-25 m-t-10 m-l-20 flex-fixed-size"
      >
        <span class="m-10">
          {{
            'sqtm-core.custom-report-workspace.create-chart-view.title'
              | translate
          }}</span
        >
      </div>
    </div>
    <div class="full-width full-height p-10" style="overflow-y: auto">
      <div
        class="full-width p-10 container-border container-background-color flex-column"
      >
        <span class="block-title">{{
          'sqtm-core.generic.label.perimeter' | translate | capitalize
        }}</span>
        @if (scope$ | async; as completeScope) {
          <sqtm-app-scope-selector
            [completeScope]="completeScope"
            [projectId]="projectId"
            (scopeChanged)="changeScope($event)"
            class="m-t-10"
          >
          </sqtm-app-scope-selector>
        }
      </div>
      <div
        class="full-width m-t-20 p-10 container-border container-background-color flex-column"
      >
        <span class="block-title">{{
          'sqtm-core.custom-report-workspace.create-chart-view.type.title'
            | translate
        }}</span>
        @if (chartType$ | async; as chartType) {
          <sqtm-app-chart-type-selector
            class="m-t-10"
            [chartType]="chartType"
            (chartTypeChanged)="changeChartType($event)"
          >
          </sqtm-app-chart-type-selector>
        }
      </div>
      <div
        class="full-width m-t-20 p-10 container-border container-background-color flex-column"
        [sqtmCoreDraggableDropZone]="'chart-workbench-axis'"
        [showHover]="true"
        (drop)="handleDropAxis($event)"
      >
        <span class="block-title">
          {{
            'sqtm-core.custom-report-workspace.create-chart-view.axis.label.plural'
              | translate
          }}
        </span>
        @if (axes$ | async; as axes) {
          @if (orderedColumnProto$ | async; as orderedColumnProto) {
            @if (chartType$ | async; as chartType) {
              @if (axes.measureRequired) {
                <sqtm-app-axis-selector
                  class="m-t-20"
                  [axis]="axes.measure"
                  [role]="columnRoles.MEASURE"
                  [chartType]="chartType"
                  [detailedAxisRole]="detailedAxisRoles.Measure"
                  [axisName]="
                    getAxisI18nKey(detailedAxisRoles.Measure) | translate
                  "
                  [columnPrototypes]="orderedColumnProto"
                  (operationChanged)="changeMeasureOperation($event)"
                  (columnChanged)="changeMeasure($event)"
                >
                </sqtm-app-axis-selector>
              }
              <sqtm-app-axis-selector
                class="m-t-20"
                [axis]="axes.axis"
                [role]="columnRoles.AXIS"
                [chartType]="chartType"
                [detailedAxisRole]="detailedAxisRoles.Axis"
                [axisName]="getAxisI18nKey(detailedAxisRoles.Axis) | translate"
                [columnPrototypes]="orderedColumnProto"
                (operationChanged)="changeAxisOperation($event)"
                (columnChanged)="changeAxis($event)"
              >
              </sqtm-app-axis-selector>
              @if (axes.seriesRequired) {
                <sqtm-app-axis-selector
                  class="m-t-20"
                  [axis]="axes.series"
                  [role]="columnRoles.AXIS"
                  [chartType]="chartType"
                  [detailedAxisRole]="detailedAxisRoles.Series"
                  [axisName]="
                    getAxisI18nKey(detailedAxisRoles.Series) | translate
                  "
                  [columnPrototypes]="orderedColumnProto"
                  (operationChanged)="changeSeriesOperation($event)"
                  (columnChanged)="changeSeries($event)"
                >
                </sqtm-app-axis-selector>
              }
            }
          }
        }
      </div>
      <div
        class="full-width m-t-20 p-10 container-border container-background-color"
        [sqtmCoreDraggableDropZone]="'chart-workbench-filters'"
        [showHover]="true"
        (drop)="handleDropFilters($event)"
      >
        <sqtm-app-filter-panel
          [columnPrototypes]="orderedColumnProto$ | async"
          [filters]="filters$ | async"
          [completeScope]="scope$ | async"
          (filterAdded)="this.addFilter($event)"
          (filterChanged)="this.changeFilter($event)"
          (filterRemoved)="this.removeFilter($event)"
        ></sqtm-app-filter-panel>
      </div>
    </div>
  </div>
  <!--  Center part, with the title of chart, the chart itself and the buttons-->
  @if (
    {
      loadingChartPreview: loadingChartPreview$ | async,
      chartPreview: chartPreview$ | async,
      savingChart: savingChart$ | async,
      hintMessages: showHintMessages$ | async
    };
    as data
  ) {
    <div class="full-height chart-zone flex-column overflow-hidden">
      <div
        class="sqtm-core-screen-title m-t-15 m-l-10 m-r-10 flex-fixed-size flex-row"
      >
        <div class="full-width">
          <sqtm-core-text-field
            [formGroup]="formGroup"
            [fieldName]="'name'"
            [serverSideFieldValidationError]="fieldValidationErrors"
            (inputBlurred)="changeName()"
          >
          </sqtm-core-text-field>
        </div>
        @if (allowAttributePanel$ | async) {
          <div class="m-l-20 flex-fixed-size">
            <i
              class="m-t-8 __hover_pointer"
              nz-icon
              [nzType]="showAttributePanelIcon$ | async"
              nzTheme="outline"
              nz-tooltip
              [nzTooltipTitle]="getAttributePanelIconTooltip$ | async"
              [nzTooltipOverlayStyle]="
                toggleButtonTooltipIsVisible ? {} : { display: 'none' }
              "
              (mouseenter)="toggleButtonTooltipIsVisible = true"
              (mouseleave)="toggleButtonTooltipIsVisible = false"
              (click)="toggleAttributeSelector()"
            ></i>
          </div>
        }
      </div>
      <div
        class="full-height full-width overflow-hidden p-l-10 p-r-10 m-b-20 m-t-30"
        style="max-height: 900px"
      >
        @if (data.loadingChartPreview === 'not_async') {
          <div
            class="full-height full-width overflow-hidden p-10 container-border container-background-color"
            [sqtmCoreDraggableDropZone]="'chart-workbench-central-chart'"
            [showHover]="true"
            (drop)="handleDropAxis($event)"
          >
            @if (data.chartPreview.isValid) {
              <sqtm-app-custom-chart
                [chartDefinition]="data.chartPreview.chartDefinition"
              ></sqtm-app-custom-chart>
            }
            @if (!data.chartPreview.isValid) {
              @if (data.hintMessages.showHintMessage) {
                <div
                  [attr.data-test-element-id]="'hint-message'"
                  class="full-width full-height flex-column font-16-px sqtm-core-centered-message"
                >
                  <div>
                    <div>
                      {{
                        'sqtm-core.custom-report-workspace.create-chart-view.error.no-axes.title'
                          | translate
                      }}
                    </div>
                    <div>
                      <ul>
                        <li>
                          {{
                            'sqtm-core.custom-report-workspace.create-chart-view.error.no-axes.click'
                              | translate
                          }}
                        </li>
                        @if (data.hintMessages.showDndHintMessage) {
                          <li>
                            {{
                              'sqtm-core.custom-report-workspace.create-chart-view.error.no-axes.dnd'
                                | translate
                            }}
                          </li>
                        }
                      </ul>
                    </div>
                  </div>
                </div>
              } @else {
                <div
                  [attr.data-test-element-id]="'missing-axes-message'"
                  class="full-width full-height flex-column font-16-px chart-message"
                >
                  {{
                    'sqtm-core.custom-report-workspace.create-chart-view.error.missing-axes'
                      | translate
                  }}
                </div>
              }
            }
          </div>
        } @else {
          <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
        }
      </div>
      <div
        class="full-width flex-fixed-size flex-row m-10"
        style="margin-top: auto"
      >
        @if (this.chartDefinition) {
          <button
            [attr.data-test-element-id]="'modify-chart'"
            class="flex-fixed-size m-l-auto"
            nz-button
            nzType="primary"
            (click)="handleModify()"
            [nzLoading]="data.savingChart === 'async'"
            [disabled]="!data.chartPreview.isValid"
          >
            {{ 'sqtm-core.generic.label.modify' | translate }}
          </button>
        }
        @if (!this.chartDefinition) {
          <button
            [attr.data-test-element-id]="'add-chart'"
            class="flex-fixed-size m-l-auto"
            nz-button
            nzType="primary"
            (click)="handleAdd()"
            [nzLoading]="data.savingChart === 'async'"
            [disabled]="!data.chartPreview.isValid"
          >
            {{ 'sqtm-core.generic.label.add' | translate }}
          </button>
        }
        <button
          [attr.data-test-element-id]="'cancel'"
          class="flex-fixed-size m-l-10 m-r-20"
          nz-button
          nzType="default"
          [disabled]="data.savingChart === 'async'"
          (click)="handleCancel()"
        >
          {{ 'sqtm-core.generic.label.cancel' | translate }}
        </button>
      </div>
    </div>
  }
  <!--  Optional right part with an attribute selector for dnd-->
  @if (showAttributePanel$ | async) {
    <div class="full-height flex-fixed-size flex-column">
      <div
        class="sqtm-core-screen-title title p-b-25 p-t-10 flex-fixed-size full-width flex-row"
      >
        <span class="m-10">
          {{
            'sqtm-core.custom-report-workspace.create-chart-view.attributes.title'
              | translate
          }}
        </span>
        <i
          [attr.data-test-icon-id]="'help-rate'"
          nz-icon
          nzType="sqtm-core-generic:help"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="
            'sqtm-core.custom-report-workspace.create-chart-view.attributes.help'
              | translate
          "
          class="current-workspace-button action-icon-size m-t-10 m-r-20 m-l-auto"
        >
        </i>
      </div>
      <div class="full-height full-width">
        @if (orderedColumnProto$ | async; as orderedColumnProto) {
          <sqtm-app-fixed-column-prototype-selector
            [columnPrototypes]="orderedColumnProto"
          ></sqtm-app-fixed-column-prototype-selector>
        }
      </div>
    </div>
  }
</div>
